<template>
  <div class="is-flex is-flex-direction-column is-align-content-center is-align-items-center is-full-width">
    <div class="m-2 is-flex is-align-items-center">
     <img :src="captchaImage"/>
      <button class="button" @click="resetCaptcha">refresh</button>
    </div>
    <input ref="captchaInput" type="text" class="input" name="captcha" placeholder="type letters above" @input="checkCaptcha">
  </div>
</template>

<script>
import { ref, onMounted } from 'vue'  
import { useStore } from 'vuex';

export default {
  name: 'Captcha',
  emits:["changed"],
  setup(props,{emit}){
      
      const captchaInput = ref(null);
      const captchaOutput = ref(null);
      const captchaImage = ref(null);

      const store = useStore();
      
      onMounted(()=>{
        resetCaptcha();
      })

      async function resetCaptcha(){
          captchaInput.value.value = "";
          // Fetch from api /captcha and fill image
          captchaImage.value = await store.dispatch("requestCaptcha")
      }

      function checkCaptcha(){
        emit('changed',captchaInput.value.value)
      }

      return {
        captchaImage,
        captchaOutput,
        captchaInput,
        resetCaptcha,
        checkCaptcha,
     }
  }
}
</script>
